SystemOrganization addCategory: #'Mercury-Prototype-RunTimeDebuggingSupport'!

Object subclass: #RunTimeDebuggingSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-RunTimeDebuggingSupport'!

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/11/2013 12:29'!
addMethod: aString inClass: aClass

	aClass compile: aString

! !

!RunTimeDebuggingSupport class methodsFor: 'package' stamp: 'NickPapoulias 1/9/2013 12:05'!
classNamed: aClassNameAsString inPackage: baseObject

	^ (baseObject classes select: [:class | class name = aClassNameAsString]) first! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/11/2013 10:29'!
contextAt: aContextIndex forProcess: aProcess
	
	[aProcess handler = nil] whileTrue: []. "active waiting on handler installation"
	aProcess handler goToStackIndex: aContextIndex.
	^ aProcess handler currentContext.! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/10/2013 15:56'!
evaluate: aString

	|exception responce|

	[[responce := Compiler evaluate: aString] on: Exception do: [:ex | 
		exception := ex.
		ex debug.
	]] fork.

	[responce = nil & exception = nil] whileTrue: []. "active waiting on computation"

	^ responce ifNil: [exception]
! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/5/2013 11:23'!
globalsDictionary

	^ Smalltalk globals! !

!RunTimeDebuggingSupport class methodsFor: 'exception' stamp: 'NickPapoulias 1/10/2013 13:16'!
handlerProcessForException: anException

	^ anException handlerProcess ! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/9/2013 15:57'!
inContext: baseObject forTempNamed: aTempName put: anObject

	baseObject tempNamed: aTempName put: anObject! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:30'!
kernelClasses

	^ {'Object'  . 'Class'  . 'ContextPart'  . 'SystemDictionary'  . 'Exception'  . 'CompiledMethod'  . 'PackageInfo'  . 'Process' } 
	! !

!RunTimeDebuggingSupport class methodsFor: 'updates' stamp: 'NickPapoulias 12/24/2012 17:04'!
metaLevelUpdate: aSystemAnnouncement! !

!RunTimeDebuggingSupport class methodsFor: 'package' stamp: 'NickPapoulias 1/11/2013 12:07'!
newClassNamed: aNewClassName inPackage: aPackage

	^ Object subclass: aNewClassName asSymbol  
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aPackage externalName. ! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/9/2013 12:08'!
newInstanceForClass: aClass

	"can be done through vm primitive"

	^ aClass new! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/11/2013 11:00'!
newPackageNamed: aPackageName

	^ PackageOrganizer default packageNamed: aPackageName ifAbsent: [(PackageInfo new packageName: aPackageName) register]! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/11/2013 10:37'!
overForProcess: aProcess 

	aProcess handler over

	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/9/2013 11:45'!
packageNamed: aPackageNameAsString 

	"this can be done through vm access in order to avoid local reflection dependency,
	after bootstraping the mirror hierarchy ideally this dependency is not needed"

	^ PackageOrganizer default packagesDictionary at: aPackageNameAsString ! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/5/2013 10:44'!
packageNames

	^ PackageOrganizer default packageNames! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/13/2013 18:34'!
packages

	^ PackageOrganizer default packages ! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/5/2013 10:48'!
packagesDictionary

	^ PackageOrganizer default packagesDictionary! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/12/2013 19:47'!
perform: aSelector withReceiver: baseObject andArguments: arguments
	
	|exception responce args|

	arguments xxx___isProxy ifTrue: [
		args := arguments asLocalObject "better as shallowCopy"		
	] ifFalse: [
		args := arguments
	].

	[[responce := baseObject perform: aSelector withArguments: args] on: Exception do: [:ex | 
		exception := ex.
		ex debug.
	]] fork.

	[responce = nil & exception = nil] whileTrue: []. "active waiting on computation"

	^ responce ifNil: [exception]! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/10/2013 13:27'!
proceedForProcess: aProcess 

	aProcess handler proceed 

	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/24/2013 16:37'!
registerExceptionListener: aRequestor

	DebuggingSeed pushNewExceptionsTo: aRequestor.! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/24/2013 16:52'!
run: aString

	[Compiler evaluate: aString] fork.! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/11/2013 12:15'!
setIvs: ivs forClass: aClass

	self vm_instVarOf: aClass at: 4 put: ivs. ! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/11/2013 10:42'!
tempNamed: aTempName inContext: aContext 

	^ aContext tempNamed: aTempName! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:07'!
vm_basicSizeOf: anObject

	"Primitive. Answer the number of indexable variables in the receiver. 
	This value is the same as the largest legal subscript. Essential. Do not 
	override in any subclass. See Object documentation whatIsAPrimitive."

	<primitive: 62>
	"The number of indexable fields of fixed-length objects is 0"
	^0	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:07'!
vm_changeClassTo: anotherClass of: anObject
	
	<primitive: 160 error: ec>
	self primitiveFailed ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 12:45'!
vm_classNameOf: anObject

	(self vm_classOf: anObject) asString! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:08'!
vm_classOf: anObject

	<primitive: 111>
	self primitiveFailed ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:08'!
vm_environment

	^ Smalltalk globals ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:08'!
vm_indexedOf: anObject at: index
	<primitive: 60>
	self primitiveFailed! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:09'!
vm_indexedOf: anObject at: index put: anotherObject
	<primitive: 61>
	self primitiveFailed! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_instSizeOf: anObject

	"see behavior type of class"
	
	|class cformat|
	
	class := self vm_classOf: anObject.
	cformat := self vm_instVarOf: class at: 3.
	^ ((cformat bitShift: -10) bitAnd: 16rC0) + ((cformat bitShift: -1) bitAnd: 16r3F) - 1
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 13:05'!
vm_instVarNamesOf: anObject

	"this can be done via primitives"

	^ (self vm_classOf: anObject) instVarNames 
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_instVarOf: anObject at: index
	<primitive: 73>
	self primitiveFailed

	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_instVarOf: anObject at: index put: anotherObject
	<primitive: 74>
	self primitiveFailed
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 13:00'!
vm_instVarOf: anObject named: anIvName

	"this can be done via primitives"

	^ anObject instVarNamed: anIvName 
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/9/2013 12:14'!
vm_instVarOf: anObject named: anIvName put: aValue

	"this can be done via primitives"

	^ anObject instVarNamed: anIvName put: aValue 
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:15'!
vm_kernelClassOf: anObject

	|classOfObject|

	classOfObject := self vm_classOf: anObject.
	
	[self kernelClasses includes: classOfObject asString] whileFalse: [
		classOfObject := self vm_instVarOf: classOfObject at: 1 "check the superclass"
	].

	^ classOfObject asString
		
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/9/2013 12:23'!
vm_objAsStringFor: baseObject

	^ baseObject asString! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_object: anObject equals: anotherObject

	<primitive: 110>
	self primitiveFailed! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_objectFormatOf: anObject

	"see behavior type of class"
	
	|class cformat|
	
	class := self vm_classOf: anObject.
	cformat := self vm_instVarOf: class at: 3.
	^ cformat! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_objectTypeOf: anObject

	"see behavior type of class"
	
	|instSpec|
	
	instSpec := ((self vm_objectFormatOf: anObject) bitShift: -7) bitAnd: 16rF.
	instSpec = 12 ifTrue:[^#compiledMethod]. "Very special!!"
	instSpec >= 8 ifTrue:[^#bytes].
	((instSpec >= 8) not and:[(instSpec >= 6)]) ifTrue:[^#words].
	instSpec = 4 ifTrue:[^#weak].
	instSpec >= 2 ifTrue:[^#variable].
	^#normal.
	! !
